#ifndef CSDL_H
#define CSDL_H

#include <SDL.h>

class CSDL
{
public:
    void            Init(Uint32 flags);
    void            Quit();

    SDL_Window*     CreateWindow(const char* title, int x, int y, int w, int h, Uint32 flags);
    void            DestroyWindow(SDL_Window* win);

    SDL_Renderer*   CreateRenderer(SDL_Window* window, int index, Uint32 flags);
    void            DestroyRenderer(SDL_Renderer* renderer);
    void            SetRenderDrawColor(SDL_Renderer* renderer, Uint8 r, Uint8 g, Uint8 b, Uint8 a);
    void            RenderClear(SDL_Renderer* renderer);
    void            RenderPresent(SDL_Renderer* renderer);
    void            RenderCopy(SDL_Renderer* renderer, SDL_Texture* texture, const SDL_Rect* srcrect, const SDL_Rect* dstrect);

    SDL_Texture*    CreateTexture(SDL_Renderer* renderer, Uint32 format, int access, int w, int h);
    void            DestroyTexture(SDL_Texture* texture);
    void            UpdateTexture(SDL_Texture* texture, const SDL_Rect* rect, const void* pixels, int pitch);

    int             PollEvent(SDL_Event* event);
    void            Delay(Uint32 ms);

private:
    void    printError(const char* funct);
};

extern CSDL sdl;

#endif // CSDL_H
